/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.basis.heldio;

import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_AKTIVIERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_ATTACKE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_BASISSTUFE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_BASISWERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_BE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_BF;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_BONUS;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_DK_H;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_DK_N;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_DK_S;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_EIGENSCHAFT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_FERNKAMPFWAFFE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_INI;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_NAHKAMPFWAFFE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_NAME;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_REICHWEITEN;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_RS;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_RUESTUNG;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_SCHADENSSCHRITT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_SCHILD;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_SCHWELLENWERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_SONDERFERTIGKEIT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_SPEZIELLE_ERFAHRUNG;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_STUFE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_TALENT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_TP;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_TP_PLUS;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_TYP;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_UNMODIFIZIERTE_STUFE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_VARIANTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_VOR_NACHTEIL;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_WM_AT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_WM_PA;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_ZAUBER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_ZUKAUF;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_ALTER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_AUGENFARBE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_AUSSEHEN;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_BASISWERT_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_BASISWERT_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_EIGENSCHAFT_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_EIGENSCHAFT_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_EINGESETZTE_AP;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_FERNKAMPFWAFFE_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_FERNKAMPFWAFFE_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GEBURTSTAG;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GESAMT_AP;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GESCHLECHT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GEWICHT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GROESSE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_HAARFARBE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_HAUSZAUBER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_HELD;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_HINTERGRUND;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_KULTUR;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_LEITTALENTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_LEITZAUBER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_MUTTERSPRACHE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_NAHKAMPFWAFFE_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_NAHKAMPFWAFFE_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_NAME;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_PROFESSION;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_RASSE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_RUESTUNG_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_RUESTUNG_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_SCHILD_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_SCHILD_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_SONDERFERTIGKEIT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_SONDERFERTIGKEIT_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_SONDERFERTIGKEIT_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_STAND;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_TALENT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_TALENT_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_TALENT_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_TITEL;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_VERBILLIGTE_SONDERFERTIGKEITEN;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_VERBILLIGTE_VARIANTEN;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_VOR_NACHTEIL_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_VOR_NACHTEIL_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_ZAUBER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_ZAUBER_WERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_ZAUBER_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_ZWEITSPRACHE;

import java.io.StringWriter;
import java.util.Collection;
import java.util.List;

import net.n3.nanoxml.IXMLElement;
import net.n3.nanoxml.XMLElement;
import net.n3.nanoxml.XMLWriter;
import de.bernhardjung.dsaprogramm.basis.FernkampfwaffeWert;
import de.bernhardjung.dsaprogramm.basis.Held;
import de.bernhardjung.dsaprogramm.basis.NahkampfwaffeWert;
import de.bernhardjung.dsaprogramm.basis.RuestungWert;
import de.bernhardjung.dsaprogramm.basis.SchildWert;
import de.bernhardjung.dsaprogramm.basiswerte.Basiswert;
import de.bernhardjung.dsaprogramm.basiswerte.BasiswertWert;
import de.bernhardjung.dsaprogramm.eigenschaften.Eigenschaft;
import de.bernhardjung.dsaprogramm.eigenschaften.EigenschaftWert;
import de.bernhardjung.dsaprogramm.sonderfertigkeiten.Sonderfertigkeit;
import de.bernhardjung.dsaprogramm.sonderfertigkeiten.SonderfertigkeitWert;
import de.bernhardjung.dsaprogramm.talente.Talent;
import de.bernhardjung.dsaprogramm.talente.TalentWert;
import de.bernhardjung.dsaprogramm.talente.Talentgruppe;
import de.bernhardjung.dsaprogramm.vornachteile.VorNachteil;
import de.bernhardjung.dsaprogramm.vornachteile.VorNachteilWert;
import de.bernhardjung.dsaprogramm.zauber.Zauber;
import de.bernhardjung.dsaprogramm.zauber.ZauberWert;

public class FactoryHeldXmlOut {

    /**
     * Fuegt die Basiswerte ins XML-Dokument ein.
     *
     * @param wurzelElement
     *            des XMl-Dokuments.
     * @param held
     *            dessen Basiswerte ins XML-Dokument eingefuegt werden sollen.
     */
    private final void appendBasiswerte(
            final IXMLElement wurzelElement,
            final Held held ) {

        final IXMLElement werteElement = new XMLElement( TAG_BASISWERT_WERTE );

        for ( final Basiswert basiswert : Basiswert.getBasiswerte() ) {

            final BasiswertWert wert = held.getWert( basiswert );

            final IXMLElement element = new XMLElement( TAG_BASISWERT_WERT );

            setAttribut( element, ATTR_BASISWERT, wert.getBasiswert().getId() );

            setAttribut( element, ATTR_BONUS, wert.getBonus() );

            setAttribut( element, ATTR_ZUKAUF, wert.getZukauf() );

            setAttribut( element, ATTR_SPEZIELLE_ERFAHRUNG,
                                  wert.hatSpezielleErfahrung() );

            werteElement.addChild( element );
        }

        wurzelElement.addChild( werteElement );
    }

    /**
     * Fuegt die Eigenschaften ins XML-Dokument ein.
     *
     * @param wurzelElement
     *            des XMl-Dokuments.
     * @param held
     *            dessen Eigenschaftn ins XML-Dokument eingefuegt werden sollen.
     */
    private final void appendEigenschaften(
            final IXMLElement wurzelElement,
            final Held held ) {

        final IXMLElement werteElement = new XMLElement( TAG_EIGENSCHAFT_WERTE );

        for ( final Eigenschaft eigenschaft :
            Eigenschaft.getEigenschaftenMitSo() ) {

            final EigenschaftWert wert = held.getWert( eigenschaft );

            final IXMLElement element = new XMLElement( TAG_EIGENSCHAFT_WERT );

            setAttribut( element, ATTR_EIGENSCHAFT,
                                  wert.getEigenschaft().getId() );

            setAttribut( element, ATTR_BASISSTUFE, wert.getBasisstufe() );

            setAttribut( element, ATTR_ZUKAUF, wert.getZukauf() );

            setAttribut( element, ATTR_SPEZIELLE_ERFAHRUNG,
                                  wert.hatSpezielleErfahrung() );

            werteElement.addChild( element );
        }

        wurzelElement.addChild( werteElement );
    }

    /**
     * Haengt ein weiters XML-Element an ein anderes Element an.
     * @param vaterElement
     *            an das das neue Element angehaengt werden soll.
     * @param name
     *            des Tags des Elements, das angehaengt werden soll.
     * @param inhalt
     *            des XML-Elements.
     */
    private final void appendElement(
            final IXMLElement vaterElement,
            final String name,
            final Object inhalt ) {

        final IXMLElement element = new XMLElement( name );

        element.setContent( inhalt.toString() );

        vaterElement.addChild( element );
    }

    /**
     * Haengt einen Wert als XML-Element an ein anderes Element an.
     *
     * @param vaterElement
     *            an das das neue Element angehaengt werden soll.
     * @param wert
     *            der in ein XML-IXMLElement umgewandelt werden soll.
     */
    private final void appendElement(
            final IXMLElement vaterElement,
            final SonderfertigkeitWert wert ) {

        final Sonderfertigkeit sonderfertigkeit = wert.getSonderfertigkeit();

        final IXMLElement element = new XMLElement( TAG_SONDERFERTIGKEIT_WERT );

        setAttribut( element, ATTR_SONDERFERTIGKEIT,
                              sonderfertigkeit.getId() );

        final Talent talent = sonderfertigkeit.getTalent();

        if ( null != talent ) {

            setAttribut( element, ATTR_TALENT, talent.getId() );
        }

        if ( sonderfertigkeit.hatVarianten() ) {

            final String variante = wert.getVariante().getId();

            setAttribut( element, ATTR_VARIANTE, variante );
        }

        vaterElement.addChild( element );
    }

    /**
     * Hangt eine Liste der Fernkampfwaffen des Helden an das Dokument an.
     * Wenn der Held keine Fernkampfwaffen traegt, macht diese Methode nichts.
     *
     * @param wurzelElement
     *            des XML-Dokument.s
     * @param held
     *            dessen Waffen angehaengt werden sollen.
     */
    private void appendFernkampfwaffen(
            final IXMLElement wurzelElement,
            final Held held ) {

        final List< FernkampfwaffeWert > waffen = held.getFernkampfwaffen();

        if ( 0 == waffen.size() ) {
            // nichts zu tun.
            return;
        }

        final IXMLElement waffenElement =
            new XMLElement( TAG_FERNKAMPFWAFFE_WERTE );

        for ( final FernkampfwaffeWert waffe : waffen ) {

            final IXMLElement waffeElement =
                new XMLElement( TAG_FERNKAMPFWAFFE_WERT );

            setAttribut( waffeElement, ATTR_FERNKAMPFWAFFE,
                                       waffe.getWaffe().getId() );

            setAttribut( waffeElement, ATTR_NAME, waffe.getName() );

            setAttribut( waffeElement, ATTR_REICHWEITEN,
                                       toString( waffe.getReichweiten() ) );

            setAttribut( waffeElement, ATTR_TALENT,
                                       waffe.getTalent().getId() );

            setAttribut( waffeElement, ATTR_TP, waffe.getTp() );

            setAttribut( waffeElement, ATTR_TP_PLUS,
                                       toString( waffe.getTpPlus() ) );

            waffenElement.addChild( waffeElement );
        }

        wurzelElement.addChild( waffenElement );
    }

    /**
     * Fuegt die Hauszauber des Helden ins Dokument ein. Macht nicht, wenn der
     * Held keine Hauszauber hat.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Hauszauber eingefuegt werden sollen.
     */
    private final void appendHauszauber(
            final IXMLElement wurzelElement,
            final Held held ) {

        final Collection< Zauber > hauszauber = held.getHauszauber();

        if ( 0 == hauszauber.size() ) {
            // nichts zu tun.
            return;
        }

        final IXMLElement zauberElement = new XMLElement( TAG_HAUSZAUBER );

        for ( final Zauber zauber : hauszauber ) {

            appendElement( zauberElement, TAG_ZAUBER, zauber.getId() );
        }

        wurzelElement.addChild( zauberElement );
    }

    /**
     * Fuegt die Liste der Leittalente ins Dokument ein. Macht nicht, wenn der
     * Held keine Leittalente hat.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Leittalente eingefuegt werden sollen.
     */
    private final void appendLeittalente(
            final IXMLElement wurzelElement,
            final Held held ) {

        final Collection< Talent > leittalente = held.getLeittalente();

        if ( 0 == leittalente.size() ) {
            // nichts zu tun.
            return;
        }

        final IXMLElement talenteElement = new XMLElement( TAG_LEITTALENTE );

        for ( final Talent talent : leittalente ) {

            appendElement( talenteElement, TAG_TALENT, talent.getId() );
        }

        wurzelElement.addChild( talenteElement );
    }

    /**
     * Fuegt die Leitzauber des Helden ins Dokument ein. Macht nicht, wenn der
     * Held keine Leitzauber hat.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Leitzauber eingefuegt werden sollen.
     */
    private final void appendLeitzauber(
            final IXMLElement wurzelElement,
            final Held held ) {

        final Collection< Zauber > leitzauber = held.getLeitzauber();

        if ( 0 == leitzauber.size() ) {
            // nichts zu tun.
            return;
        }

        final IXMLElement zauberElement = new XMLElement( TAG_LEITZAUBER );

        for ( final Zauber zauber : leitzauber ) {

            appendElement( zauberElement, TAG_ZAUBER, zauber.getId() );
        }

        wurzelElement.addChild( zauberElement );
    }

    /**
     * Fuegt die Nahkampfwaffen, die der Held traegt, in das Dokument ein.
     * Macht nichts, wenn der Held keine Nahkampfwaffen traegt.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Nahkampfwaffen ins Dokument eingefuegt werden sollen.
     */
    private final void appendNahkampfwaffen(
            final IXMLElement wurzelElement,
            final Held held ) {

        final Collection< NahkampfwaffeWert > waffen = held.getNahkampfwaffen();

        if ( 0 == waffen.size() ) {
            // nichts zu tun.
            return;
        }

        final IXMLElement waffenElement =
            new XMLElement( TAG_NAHKAMPFWAFFE_WERTE );

        for ( final NahkampfwaffeWert waffe : waffen ) {

            final IXMLElement waffeElement =
                new XMLElement( TAG_NAHKAMPFWAFFE_WERT );

            setAttribut( waffeElement, ATTR_BF, waffe.getBf() );

            setAttribut( waffeElement, ATTR_DK_H, waffe.istDkH() );

            setAttribut( waffeElement, ATTR_DK_N, waffe.istDkN() );

            setAttribut( waffeElement, ATTR_DK_S, waffe.istDkS() );

            setAttribut( waffeElement, ATTR_INI, waffe.getIni() );

            setAttribut( waffeElement, ATTR_NAME, waffe.getName() );

            setAttribut( waffeElement, ATTR_SCHADENSSCHRITT,
                                       waffe.getSchadensschritt() );

            setAttribut( waffeElement, ATTR_SCHWELLENWERT,
                                       waffe.getSchwellenwert() );

            setAttribut( waffeElement, ATTR_TALENT, waffe.getTalent().getId() );

            setAttribut( waffeElement, ATTR_TP, waffe.getTp() );

            setAttribut( waffeElement, ATTR_NAHKAMPFWAFFE,
                                       waffe.getWaffe().getId() );

            setAttribut( waffeElement, ATTR_WM_AT, waffe.getWmAt() );

            setAttribut( waffeElement, ATTR_WM_PA, waffe.getWmPa() );

            waffenElement.addChild( waffeElement );
        }

        wurzelElement.addChild( waffenElement );
    }

    /**
     * Haengt eine Liste der Ruestungen des Helden an das Dokument an. Macht
     * nichts, wenn der Held keine Ruestung traegt.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Ruestungen in das Dokument eingefuegt werden sollen.
     */
    private void appendRuestungen(
            final IXMLElement wurzelElement,
            final Held held ) {

        final List< RuestungWert > ruestungen = held.getRuestungen();

        if ( 0 == ruestungen.size() ) {
            // nichts zu tun.
            return;
        }

        final IXMLElement ruestungenElement =
            new XMLElement( TAG_RUESTUNG_WERTE );

        for ( final RuestungWert ruestung : ruestungen ) {

            final IXMLElement ruestungElement =
                new XMLElement( TAG_RUESTUNG_WERT );

            setAttribut( ruestungElement, ATTR_BE, ruestung.getBe() );

            setAttribut( ruestungElement, ATTR_NAME, ruestung.getName() );

            setAttribut( ruestungElement, ATTR_RUESTUNG,
                                          ruestung.getRuestung().getId() );

            setAttribut( ruestungElement, ATTR_RS, ruestung.getRs() );

            ruestungenElement.addChild( ruestungElement );
        }

        wurzelElement.addChild( ruestungenElement );
    }

    /**
     * Haengt eine Liste der Schilde des Helden an das Dokument an. Macht
     * nichts, wenn der Held keine Schilde hat.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Schilde in das Dokument eingefuegt werden sollen.
     */
    private void appendSchilde(
            final IXMLElement wurzelElement,
            final Held held ) {

        final List< SchildWert > schilde = held.getSchilde();

        if ( 0 == schilde.size() ) {
            // nichts zu tun.
            return;
        }

        final IXMLElement schildeElement =
            new XMLElement( TAG_SCHILD_WERTE );

        for ( final SchildWert schild : schilde ) {

            final IXMLElement schildElement =
                new XMLElement( TAG_SCHILD_WERT );

            setAttribut( schildElement, ATTR_BF, schild.getBf() );

            setAttribut( schildElement, ATTR_INI, schild.getIni() );

            setAttribut( schildElement, ATTR_NAME, schild.getName() );

            setAttribut( schildElement, ATTR_SCHILD,
                                          schild.getSchild().getId() );

            setAttribut( schildElement, ATTR_TYP, schild.getTyp().getId() );

            setAttribut( schildElement, ATTR_WM_AT, schild.getWmAt() );

            setAttribut( schildElement, ATTR_WM_PA, schild.getWmPa() );

            schildeElement.addChild( schildElement );
        }

        wurzelElement.addChild( schildeElement );
    }

    /**
     * Fuegt die Sonderfertigkeiten des Helden in das XML-Dokument ein. Wenn der
     * Held keine Sonderfertigkeiten besitzt, so macht die Methode nichts.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Werte eingefuegt werden sollen.
     */
    private final void appendSonderfertigkeiten(
            final IXMLElement wurzelElement,
            final Held held ) {

        final List< SonderfertigkeitWert > sonderfertigkeiten =
            held.getSonderfertigkeiten();

        if ( 0 == sonderfertigkeiten.size() ) {
            // nichts zu tun
            return;
        }

        final IXMLElement werteElement = new XMLElement( TAG_SONDERFERTIGKEIT_WERTE );

        for ( final SonderfertigkeitWert wert : sonderfertigkeiten ) {

            appendElement( werteElement, wert );
        }

        wurzelElement.addChild( werteElement );
    }

    /**
     * Fuegt die Talentwerte des Helden ins XML-Dokument ein.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Werte eingefuegt werden sollen.
     */
    private final void appendTalente(
            final IXMLElement wurzelElement,
            final Held held ) {

        final IXMLElement werteElement = new XMLElement( TAG_TALENT_WERTE );

        for ( final Talent talent : held.getTalente() ) {

            final TalentWert wert = held.getWert( talent );

            final IXMLElement element = new XMLElement( TAG_TALENT_WERT );

            setAttribut( element, ATTR_TALENT, talent.getId() );

            setAttribut( element, ATTR_UNMODIFIZIERTE_STUFE,
                                  wert.getUnmodifizierteStufe() );

            setAttribut( element, ATTR_SPEZIELLE_ERFAHRUNG,
                                  wert.hatSpezielleErfahrung() );

            if ( ! wert.istAktiviert() && ( 0 == wert.getStufe( held ) ) ) {

                setAttribut( element, ATTR_AKTIVIERT, "false" );
            }

            if ( Talentgruppe.KAMPF.equals( talent.getTalentgruppe() ) ) {

                setAttribut( element, ATTR_ATTACKE, wert.getAttacke() );
            }

            werteElement.addChild( element );
        }

        wurzelElement.addChild( werteElement );
    }

    /**
     * Fuegt dem XML-Dokument die Liste der verbilligten Sonderfertigkeiten
     * hinzu.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen verbilligte Sonderfertigkeiten hinzugefuegt werden
     *            sollen.
     */
    private final void appendVerbilligteSonderfertigkeiten(
            final IXMLElement wurzelElement,
            final Held held ) {

        final List< Sonderfertigkeit > sonderfertigkeiten =
            held.getVerbilligteSonderfertigkeiten();

        if ( 0 == sonderfertigkeiten.size() ) {
            // nichts zu tun
            return;
        }

        final IXMLElement sonderfertigkeitenElement =
            new XMLElement(TAG_VERBILLIGTE_SONDERFERTIGKEITEN);

        for ( final Sonderfertigkeit sonderfertigkeit : sonderfertigkeiten ) {

            final IXMLElement sfElement = new XMLElement( TAG_SONDERFERTIGKEIT );

            setAttribut( sfElement, ATTR_SONDERFERTIGKEIT,
                                    sonderfertigkeit.getId() );

            final Talent talent = sonderfertigkeit.getTalent();

            if ( null != talent ) {

                setAttribut( sfElement, ATTR_TALENT, talent.getId() );
            }

            sonderfertigkeitenElement.addChild( sfElement );
        }

        wurzelElement.addChild( sonderfertigkeitenElement );
    }

    /**
     * Haengt die Sonderfertigkeiten von denen eine Variante verbilligt ist an
     * das XML-Dokument an. Wenn der Held keine verbilligten Varianten hat,
     * macht die Methode nichts.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen verbilligte Varianten angehaengt werden sollen.
     */
    private final void appendVerbilligteVarianten(
            final IXMLElement wurzelElement,
            final Held held ) {

        final List< SonderfertigkeitWert > varianten =
            held.getVerbilligteVarianten();

        if ( 0 == varianten.size() ) {
            // nichts zu tun
            return;
        }

        final IXMLElement werteElement = new XMLElement( TAG_VERBILLIGTE_VARIANTEN );

        for ( final SonderfertigkeitWert wert : varianten ) {

            appendElement( werteElement, wert );
        }

        wurzelElement.addChild( werteElement );
    }

    private final void appendVorNachteile(
            final IXMLElement wurzelElement,
            final Held held ) {

        final List< VorNachteilWert > vorNachteile = held.getVorNachteile();

        if ( 0 == vorNachteile.size() ) {
            // nichts zu tun
            return;
        }

        final IXMLElement werteElement = new XMLElement( TAG_VOR_NACHTEIL_WERTE );

        for ( final VorNachteilWert wert : vorNachteile ) {

            final IXMLElement element = new XMLElement( TAG_VOR_NACHTEIL_WERT );

            final VorNachteil vorNachteil = wert.getVorNachteil();

            setAttribut( element, ATTR_VOR_NACHTEIL, vorNachteil.getId() );

            if ( wert.hatSpezielleErfahrung() ) {

                setAttribut( element, ATTR_SPEZIELLE_ERFAHRUNG,
                             "true" );
            }

            if ( vorNachteil.hatStufen() ) {

                setAttribut( element, ATTR_STUFE, wert.getStufe() );
            }

            if ( vorNachteil.hatVarianten() ) {

                final Object variante = wert.getVariante().getId();

                setAttribut( element, ATTR_VARIANTE, variante );
            }

            werteElement.addChild( element );
        }

        wurzelElement.addChild( werteElement );
    }

    /**
     * Fuegt die Zauber des Helden in das XML-Dokument ein. Macht nichts, wenn
     * der Held keine Zauber beherrscht.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @param held
     *            dessen Zauber eingefuegt werden sollen.
     */
    private final void appendZauber(
            final IXMLElement wurzelElement,
            final Held held ) {

        final List< ZauberWert > zauber = held.getZauber();

        if ( 0 == zauber.size() ) {
            // nichts zu tun
            return;
        }

        final IXMLElement werteElement = new XMLElement( TAG_ZAUBER_WERTE );

        for ( final ZauberWert wert : zauber ) {

            final IXMLElement element = new XMLElement( TAG_ZAUBER_WERT );

            setAttribut( element, ATTR_ZAUBER, wert.getZauber().getId() );

            setAttribut( element, ATTR_STUFE, wert.getStufe() );

            setAttribut( element, ATTR_SPEZIELLE_ERFAHRUNG,
                                  wert.hatSpezielleErfahrung() );

            if ( wert.getZauber().hatVarianten() ) {

                setAttribut( 
                        element, 
                        ATTR_VARIANTE, 
                        wert.getVariante().getId() );
            }

            werteElement.addChild( element );
        }

        wurzelElement.addChild( werteElement );
    }

    /**
     * Liefert einen Helden als XML-Dokument.
     *
     * @param held
     *            der in ein XML-Dokument umgewandelt werden soll.
     * @return
     */
    public final String erzeugen( final Held held ) {

        final IXMLElement wurzelElement = new XMLElement( TAG_HELD );

        appendElement( wurzelElement, TAG_NAME, held.getName() );

        appendElement( wurzelElement, TAG_RASSE, held.getRasse().getId() );

        appendElement( wurzelElement, TAG_KULTUR, held.getKultur().getId() );

        appendElement(
                wurzelElement, TAG_PROFESSION, held.getProfession().getId() );

        appendElement(
                wurzelElement, TAG_GESCHLECHT, held.getGeschlecht().name() );

        appendElement( wurzelElement, TAG_GEBURTSTAG, held.getGeburtstag() );

        appendElement( wurzelElement, TAG_ALTER, held.getAlter() );

        appendElement( wurzelElement, TAG_GROESSE, held.getGroesse() );

        appendElement( wurzelElement, TAG_GEWICHT, held.getGewicht() );

        final String haarfarbeId = held.getHaarfarbe().getId();
        
        appendElement( wurzelElement, TAG_HAARFARBE, haarfarbeId );

        final String augenfarbeId = held.getAugenfarbe().getId();
        
        appendElement( wurzelElement, TAG_AUGENFARBE, augenfarbeId );

        appendElement( wurzelElement, TAG_AUSSEHEN, held.getAussehen() );

        appendElement( wurzelElement, TAG_STAND, held.getStand() );

        appendElement( wurzelElement, TAG_TITEL, held.getTitel() );

        appendElement( wurzelElement, TAG_HINTERGRUND, held.getHintergrund() );

        appendElement( wurzelElement, TAG_GESAMT_AP, held.getApGesamt() );

        appendElement(
                wurzelElement, TAG_EINGESETZTE_AP, held.getApEingesetzt() );

        appendEigenschaften( wurzelElement, held );

        appendBasiswerte( wurzelElement, held );

        appendElement( wurzelElement, TAG_MUTTERSPRACHE,
                                      held.getMuttersprache().getId() );

        if ( held.hatZweitsprache() ) {

            appendElement( wurzelElement, TAG_ZWEITSPRACHE,
                                          held.getZweitsprache().getId() );
        }

        appendTalente( wurzelElement, held );

        appendLeittalente( wurzelElement, held );

        appendZauber( wurzelElement, held );

        appendHauszauber( wurzelElement, held );

        appendLeitzauber( wurzelElement, held );

        appendSonderfertigkeiten( wurzelElement, held );

        appendVerbilligteSonderfertigkeiten( wurzelElement, held );

        appendVerbilligteVarianten( wurzelElement, held );

        appendVorNachteile( wurzelElement, held );

        appendNahkampfwaffen( wurzelElement, held );

        appendFernkampfwaffen( wurzelElement, held );

        appendRuestungen( wurzelElement, held );

        appendSchilde( wurzelElement, held );

        final StringWriter stringWriter = new StringWriter();

        final XMLWriter xmlWriter = new XMLWriter( stringWriter );

        try {

            xmlWriter.write( wurzelElement, true );

        } catch ( final Exception e ) {
            e.printStackTrace();
        }

        return stringWriter.toString();
    }

    /**
     * Fuegt einem XML-IXMLElement ein Attribut hinzu.
     *
     * @param element
     *            das das Attribut erhalten soll.
     * @param name
     *            der Name des Attributs.
     * @param wert
     *            den das Attrbiut haben soll. Wird mittels
     *            {@link Object#toString()} in einen String umgewandelt.
     */
    private final void setAttribut(
            final IXMLElement element,
            final String name,
            final Object wert ) {

        element.setAttribute( name, wert.toString() );
    }

    /**
     * Wandelt eine Liste in einen String um, in dem die Elemente der Liste
     * durch Komma getrennt sind.
     *
     * @param liste
     *            die in den String umgewandelt werden soll.
     * @return die Liste als String.
     */
    private String toString( final List< Integer > liste ) {

        final StringBuilder builder = new StringBuilder();

        builder.append( liste.get( 0 ) );

        for ( int i = 1, n = liste.size() ; i < n ; ++i ) {

            builder.append( "," );
            builder.append( liste.get( i ) );
        }

        return builder.toString();
    }
}
