/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.daten.factorys.bausteine;

import static de.bernhardjung.dsaprogramm.daten.xml.HeldenbausteinXmlTags.TAG_LEITTALENTE;

import java.util.ArrayList;
import java.util.List;

import net.n3.nanoxml.IXMLElement;
import de.bernhardjung.dsaprogramm.talente.Talent;

public class FactoryLeittalenteIn {

    /**
     * @param wurzelElement des XML-Dokuments.
     * @return eine Liste von Leittalenten.
     */
    public final List< Talent > erzeugen( final IXMLElement wurzelElement ) {

        final List< Talent > leittalente = new ArrayList<Talent>();

        final IXMLElement leittalenteElement =
            wurzelElement.getFirstChildNamed( TAG_LEITTALENTE );

        if ( null != leittalenteElement ) {

            for ( final IXMLElement leittalentElement :
                leittalenteElement.getChildren() ) {

                final String id = leittalentElement.getContent();

                leittalente.add( Talent.getTalent( id ) );
            }

        }

        return leittalente;
    }
}
