/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Observable;

import javax.swing.JComboBox;

import de.bernhardjung.dsaprogramm.basis.Lernmethode;

public class Lernmethoden extends Observable implements ActionListener {

    public static final Object LERNMETHODE = new Object();

    private final JComboBox comboBox;

    public Lernmethoden( final JComboBox dieComboBox ) {

        comboBox = dieComboBox;

        comboBox.addActionListener( this );
    }

    public void actionPerformed( final ActionEvent e ) {
        setChanged();

        notifyObservers( LERNMETHODE );
    }

    public final Lernmethode getLernmethode() {
        return (Lernmethode) comboBox.getSelectedItem();
    }
}
