/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.bernhardjung.dsaprogramm.gui;

import java.awt.LayoutManager;


public abstract class WechselbaresPanel extends ResetbaresPanel {
    
    public WechselbaresPanel() {
        
        super();
    }
    
    public WechselbaresPanel( final LayoutManager layoutManager ) {
        
        super( layoutManager );
    }
    
    /**
     * Wird vom Hauptpanel aufgerufen, bevor dieses Panel durch ein anderes
     * Panel ersetzt wird. Eine evtl. Nachfrage beim Benutzer, ob das Panel
     * wirklich gewechselt werden soll, oder ob Daten gespeicher werden sollen
     * sollte von dieser Methode uebernommen werden.
     * 
     * @return {@code true}, wenn das Panel ausgeblendet werden kann, sonst
     *          {@code false}.
     */
    public abstract boolean kannGewechseltWerden();
}
