/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.gui.action;

import de.bernhardjung.dsaprogramm.gui.DialogEinstellungen;
import de.bernhardjung.dsaprogramm.gui.Hauptpanel;

public class ActionEinstellungen extends CharGenAction {
    
    /** Der Dialog den die Action anzeigt. */
    private DialogEinstellungen dialogEinstellungen;

    public ActionEinstellungen( final Hauptpanel dasHauptpanel ) {

        super( dasHauptpanel, "ActionEinstellungen.Name", "sprache" );
        
        neuUebersetzen();
    }

    /**
     * Macht den Dialog fuer die Einstellungen sichtbar oder unsichtbar.
     */
    public void actionPerformed() {
        
        getDialogEinstellungen().setVisible( 
                ! getDialogEinstellungen().isVisible() );
    }

    public DialogEinstellungen getDialogEinstellungen() {
        
        if ( null == dialogEinstellungen ) {
            
            dialogEinstellungen = new DialogEinstellungen( 
                    hauptpanel.getHauptfenster(),
                    hauptpanel );
            
            dialogEinstellungen.setLocationRelativeTo( hauptpanel );
        }

        return dialogEinstellungen;
    }

    public void neuUebersetzen() {

        super.neuUebersetzen();
        
        if ( null != dialogEinstellungen ) {
            
            dialogEinstellungen.neuUebersetzen();
        }
    }
}
