/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */

package de.bernhardjung.dsaprogramm.gui.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.UIManager;
import javax.swing.UIManager.LookAndFeelInfo;

import de.bernhardjung.dsaprogramm.gui.Hauptpanel;
import de.bernhardjung.dsaprogramm.util.Einstellungen;

public class ActionLookAndFeel extends AbstractAction {

    private final Hauptpanel hauptpanel;
    
    private final String lookAndFeel;
    
    public ActionLookAndFeel( 
            final LookAndFeelInfo dasLookAndFeel,
            final Hauptpanel dasHauptpanel ) {

        super( dasLookAndFeel.getName() );

        hauptpanel = dasHauptpanel;
        
        lookAndFeel = dasLookAndFeel.getClassName();
    }
    
    public void actionPerformed( ActionEvent e ) {
        
        try {
            
            hauptpanel.zeigeWartenMauszeiger();
            
            UIManager.setLookAndFeel( lookAndFeel );
            
            Einstellungen.getInstanz().setLookAndFeel( lookAndFeel );
            
            hauptpanel.aktualisiereLookAndFeel();
            
        } catch ( Exception ex ) {
            // ignorieren.
        } finally {
            
            hauptpanel.zeigeStandardMauszeiger();
        }
    }
}
