/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.gui.action;

import de.bernhardjung.dsaprogramm.bausteine.Heldenbaustein;
import de.bernhardjung.dsaprogramm.bausteine.Kultur;
import de.bernhardjung.dsaprogramm.daten.Datenkonstanten;
import de.bernhardjung.dsaprogramm.daten.Datenspeicher;
import de.bernhardjung.dsaprogramm.gui.Hauptpanel;

public class ActionSpeichernKultur extends ActionSpeichernHeldenbaustein {

    public ActionSpeichernKultur( final Hauptpanel dasHauptpanel ) {
        
        super( dasHauptpanel,
                "ActionSpeichernKultur.Name",
                "ActionSpeichernKultur.Mnemonic" );
    }

    @Override
    Heldenbaustein getHeldenbaustein() {

        final String id = getHeldenbausteinId();

        final Datenspeicher speicher = Datenspeicher.getInstanz();

        final Kultur kultur = speicher.getKultur( id );

        hauptpanel.getPanelMetaKultur().uebertrageDaten( kultur );

        speicher.einfuegen( kultur );

        return kultur;
    }

    @Override
    String getHeldenbausteinId() {
        return hauptpanel.getPanelMetaKultur().getKulturId();
    }

    @Override
    String getHeldenbausteinName() {
        return hauptpanel.getPanelMetaKultur().getKulturName();
    }

    @Override
    String getIdPraefix() {
        return "Kultur.";
    }

    @Override
    String getUnterverzeichnis() {
        return Datenkonstanten.VERZEICHNIS_KULTUREN;
    }

    @Override
    String getDateierweiterung() {
        return Datenkonstanten.DATEIERWEITERUNG_KULTUR;
    }

}
