/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.gui.meta;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.layout.FormLayout;

import de.bernhardjung.dsaprogramm.bausteine.Profession;
import de.bernhardjung.dsaprogramm.bausteine.bonus.BesondererBesitz;
import de.bernhardjung.dsaprogramm.gui.ResetbaresPanel;
import de.bernhardjung.dsaprogramm.util.Uebersetzbar;
import de.bernhardjung.dsaprogramm.util.Util;

class PanelMetaBesondererBesitz
extends ResetbaresPanel
implements ActionListener, Uebersetzbar {

    /** Der eigentliche Inhalt des Panels. */
    private final JPanel inhalt;
    
    /** Ein Knopf mit dem eine weiteres Textfeld angezeigt wird. */
    private final JButton plus;

    
    
    private final List< JTextField > textfelder;

    PanelMetaBesondererBesitz() {

        super( new BorderLayout() );

        
        
        inhalt = new JPanel();
        
        textfelder = new ArrayList< JTextField >();

        plus = new JButton( "+" );
        plus.addActionListener( this );

        final JScrollPane scrollPane = Util.erzeugeScrollPane( inhalt );
        resetter.einfuegen( scrollPane );
        
        setLayout( new BorderLayout() );
        
        add( scrollPane, BorderLayout.CENTER );
        
        aufbauenBenutzeroberflaeche();
    }

    private final void aufbauenBenutzeroberflaeche() {

        inhalt.removeAll();

        final FormLayout layout = new FormLayout( "P:G" );

        final DefaultFormBuilder builder = 
            new DefaultFormBuilder( layout, inhalt );

        builder.setDefaultDialogBorder();

        for ( final JTextField textfeld : textfelder ) {

            builder.append( textfeld );
        }

        builder.append( plus );

        inhalt.doLayout();
    }

    public final void actionPerformed( final ActionEvent e ) {

        textfelder.add( new JTextField() );

        aufbauenBenutzeroberflaeche();
    }

    public final void anzeigen( final Profession profession) {

        final List< BesondererBesitz > besitz =
            profession.getBesondererBesitzObjekte();

        eingabenLoeschen();

        for ( int i = textfelder.size(), n = besitz.size() ; i < n ; ++i ) {

            textfelder.add( new JTextField() );
        }

        for ( int i = 0, n = besitz.size() ; i < n ; ++i ) {

            textfelder.get( i ).setText( besitz.get( i ).getId() );
        }

        aufbauenBenutzeroberflaeche();
    }

    public final List< BesondererBesitz > getBesondererBesitz() {

        final List< BesondererBesitz > besitz =
            new ArrayList< BesondererBesitz >();

        for ( final JTextField textfeld : textfelder ) {

            final String text = textfeld.getText().trim();

            if ( ! text.equals( "" ) ) {

                besitz.add( new BesondererBesitz( text ) );
            }
        }

        return besitz;
    }
    
    public void neuUebersetzen() {
        // Nix zu tun.
    }

    /** Leert alle Textfelder. */
    public void eingabenLoeschen() {

        for ( final JTextField textfeld : textfelder ) {

            textfeld.setText( "" );
        }

    }
}
