/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.vornachteile.anpasser;

import de.bernhardjung.dsaprogramm.basis.Held;
import de.bernhardjung.dsaprogramm.vornachteile.VorNachteilWert;

class AnpasserFettleibig implements Anpasser {

    /**
     * Aendert das Gewicht auf einen zu Fettleibig passenden Wert.
     */
    public void eingefuegt( final Held held, final VorNachteilWert wert ) {

        final int gewicht = held.getRasse().getGewicht().berechnen( held );

        held.setGewicht( gewicht );
    }

    /**
     * Aendert das Gewicht des Helden auf einen normalen Wert.
     */
    public void entfernt( final Held held, final VorNachteilWert wert ) {

        final int gewicht = held.getRasse().getGewicht().berechnen( held );

        held.setGewicht( gewicht );
    }

    public void stufeGeaendert( final Held held, final VorNachteilWert wert ) {
        // nichts zu tun.
    }

    public void geaendertVariante(
            final Held held,
            final Object alteVariante,
            final Object neueVariante ) {
        // nichts zu tun.
    }

}
