/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.vornachteile.kosten;

import de.bernhardjung.dsaprogramm.basis.Lernmethode;

public class KostenStufeSchlechteEigenschaft extends KostenStufe {

    KostenStufeSchlechteEigenschaft(final int dieKosten, final int proStufe) {
        super( dieKosten, proStufe );
    }

    /** {@inheritDoc} */
    public int getSenkungskosten( final Lernmethode lernmethode ) {

        final double faktor;
        switch( lernmethode ) {
        case LEHRMEISTER:
        case KEINE:
        case SPEZIELLE_ERFAHRUNG:
            faktor = -50.0;
            break;

            default:
                faktor = -75.0;
        }

        return (int) Math.round( faktor * kosten / pro );
    }

}
