/*
 * This file is part of the TDE Character Generator (TCG).
 *
 * TCG is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TCG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TCG.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.bernhardjung.dsaprogramm.vornachteile.stufen;

import java.util.Collection;
import java.util.Collections;

import de.bernhardjung.dsaprogramm.basis.Held;

class StufenKeine implements Stufen {

    /** @return eine leere Liste. */
    @SuppressWarnings( "unchecked" )
    public Collection<Object> getAbhaengigkeiten() {
        return Collections.EMPTY_LIST;
    }
    
    /** @return 0 */
    public int getHoechststufe(Held held) {
        return 0;
    }

    /** @return 0 */
    public int getMindeststufe() {
        return 0;
    }

    /** @return 0 */
    public int getMindeststufe(Held held) {
        return 0;
    }

    /** @return 0 */
    public int getSchrittweite() {
        return 0;
    }

    /** @return {@code false} */
    public boolean hatStufen() {
        return false;
    }
}
